/**************************************************************************/
/* rxFtpTree.cmd - 室 ॢ ⠫ FTP-ࢥ               v0.04 */
/*========================================================================*/
/*                                                                        */
/* ⠪:                                                             */
/*    rxFtpTree [login[:password]@]host[/dir] [level][:mode][:delay]      */
/*                                                                        */
/* ࠬ:                                                             */
/*    login    -  짮⥫ ftp-ࢥ                             */
/*               ( 㬮砭: anonymous)                                */
/*    password - ஫                                                   */
/*               ( 㬮砭: anonymous@guest.ftp)                      */
/*    host     -    ftp-ࢥ                                */
/*    dir      -  ⠫,  ண 筥 ஥ ॢ      */
/*    level    - ᨬ ஢  ⠫:  1  9 */
/*               ( 㬮砭: 1)                                        */
/*    mode     - ० FTP:                                               */
/*                  a - ⨢                                          */
/*                  p - ᨢ ( 㬮砭)                          */
/*    delay    - প ।  믮 FtpDir,  ᥪ㭤.          */
/*                ⠪ ࢥ FTP ᨫ쭮 ᨫ  㡮       */
/*               ஢     嫥뢠         */
/*               ( 㬮砭: 0)                                        */
/*     ࠬ஢ - 뢮 ᪠                                    */
/*                                                                        */
/* ਬ:   rxFtpTree ftp.boulder.ibm.com                               */
/*            rxFtpTree ftp.boulder.ibm.com/ps/products/os2 3             */
/*            rxFtpTree friend@ftp.local 5:a:2                            */
/*            rxFtpTree user:qwerty@ftp.local :p                          */
/*            rxFtpTree user:qwerty@ftp.local :a:1                        */
/*            rxFtpTree admin:admin@mail.local@ftp.local :1               */
/*                                                                        */
/* ஥ ६:                                                */
/*    mr.OutDir   -  ⠫,    ᪫뢠 室   */
/*                  䠩; ᫨ ⠫  ,  ᯮ    */
/*                  ⥪騩 ⠫ ( 㬮砭).                       */
/*    mr.TimeOut  - ⠩ ᠭ,  ᥪ㭤.                        */
/*                  ᫨ ६ 믮 横   ⠫    */
/*                  ॢ蠥 㪠 祭,  ᫥         */
/*                  Ctrl-C 㤥 ⥫쭮 । த      */
/*                  믮  窨 뢠.                        */
/*                  筮 REXX FTP API 墠⠥ 600 ᥪ, ⮡ ࠢ */
/*                   묨 訡,   - 饩      */
/*                  ࠡ⪨   㧪 ᠭ -⠪  */
/*                   (. ॢ 㬥樨)                  */
/*                                                                        */
/*========================================================================*/
/* CopyLeft VicTor Smirnoff, 2010                       iamvic@rambler.ru */
/*------------------------------------------------------------------------*/
mr.CodePage = 1251  /* ஢ 짮⥫  ࢥ FTP              */
mr.OutDir   = '.\'  /* ⠫  室 䠩                        */
mr.TimeOut  = 0     /* ⠩- ᠭ;  Ctrl-C । த */

mr.Version    = 'rxFtpTree v0.04'
mr.CopyLeft   = '(C)opyLeft VicTor Smirnoff, 2010'
mr.Email      = 'iamvic@rambler.ru'

rc = xGetAnsiValue()

mr.StartDate = Date('L')
mr.StartTime = Time('N')

say mr.c.Reset
say mr.b.W||mr.Version||'   '||mr.CopyLeft||'     '||mr.Email
say mr.c.Reset
say 'Start: '||mr.StartDate||' '||mr.StartTime

/**************************************************************************/
/*  ࠬ஢  㧪 ⥪                                 */
/**************************************************************************/
parse arg pParam

ftp.Host = xParseParam( pParam, 'HOST' )
if ftp.Host = '' then do
   rc = xHowUse()
end
ftp.Login = xParseParam( pParam, 'LOGIN' )
ftp.Passwd = xParseParam( pParam, 'PASSWORD' )
ftp.Dir = xParseParam( pParam, 'DIR' )
mr.MaxLevel = xParseParam( pParam, 'LEVEL' )
mr.FtpMode = xParseParam( pParam, 'MODE' )
mr.Delay = xParseParam( pParam, 'DELAY' )

mr.OutDir = Strip( mr.OutDir)
if mr.OutDir \= '.\' then do
   if \xIsDirExist( mr.OutDir ) then do
      mr.OutDir = '.\'
   end
   else do
      if Right( mr.OutDir, 1 ) \= '\' then do
         mr.OutDir = mr.OutDir||'\'
      end
   end
end

mr.CurrentLevel = 0
mr.OutFile  = mr.OutDir||ftp.Host||'.dir'
mr.Sys = ''
mr.Version = ''
mr.IsHalt = 0
mr.IsRestore = 0
mr.Save.0 = 0

if RxFuncQuery( 'SysLoadFuncs' ) then do
   rc = RxFuncAdd( 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs' )
   rc = SysLoadFuncs( )
end

if RxFuncQuery( 'FtpLoadFuncs' ) then do
   rc = RxFuncAdd( 'FtpLoadFuncs', 'rxFtp', 'FtpLoadFuncs' )
   rc = FtpLoadFuncs( 0 )
end

if Stream( mr.OutFile, 'C', 'QUERY EXIST' ) \= '' then do
   rc = SysFileDelete( mr.OutFile )
end

signal on halt

/**************************************************************************/
/* ଠ  砫 ࠬ                                      */
/**************************************************************************/
drop mr.Version
rc = FtpVersion( mr.Version )
say mr.c.Reset
say 'REXX FTP API Version is '||mr.b.Y||mr.Version||mr.n.W
say '         Remote Host is '||mr.b.Y||ftp.Host||mr.n.W
say '    Remote Host User is '||mr.b.Y||ftp.Login||mr.n.W
say 'Remote Host Password is '||mr.b.Y||ftp.Passwd||mr.n.W
if ftp.Dir = '' then do
   x.d = '/'
end
else do
   x.d = ftp.Dir
end
say '     Start Directory is '||mr.b.Y||x.d||mr.n.W
say '         Output File is '||mr.b.Y||mr.OutFile||mr.n.W

/**************************************************************************/
/* ଠ  ࢥ FTP                                               */
/**************************************************************************/
x.l = ' Ping to Remote Host is '
say x.l||mr.b.G||'(wait please)'||mr.n.W||mr.c.Mu
rc = FtpPing( ftp.Host, 64 )
if DataType( rc, 'N' ) then do
   x.l = mr.c.Cl||x.l||mr.b.Y||rc||' ms'||mr.n.W
end
else do
   x.l = mr.c.Cl||x.l||mr.b.R||rc||xFtpPingError( rc )||mr.n.W
end
say x.l
if rc = 'PINGHOST' | ,
   rc = 'PINGSOCKET' then do
   signal halt
end

rc = FtpSetUser( ftp.Host, ftp.Login, ftp.Passwd )
if rc \= 1 then do
   x.l = mr.b.R||'FtpSetUser()   RC='||rc||' - parameter failure'||mr.n.W
   say x.l
   signal halt
end

say ' Connect to Remote Host '|| ,
    mr.b.G||'(wait please)'||mr.n.W||mr.c.Mu

drop mr.Sys
rc = FtpSys( mr.Sys )
if rc = -1 then do
   rc = xCheckError( rc, 'FtpSys()' )
   signal halt
end
else do
   x.l = '      Remote Host OS is '
   x.l = mr.c.Cl||x.l||mr.b.Y||mr.Sys||mr.n.W
   say x.l
end

mr.Sys = Translate(Strip( mr.Sys ))

/**************************************************************************/
/* ⠭ ० FTP                                                */
/**************************************************************************/
rc = FtpSetActiveMode( mr.FtpMode )
select
   when rc = 1 & mr.FtpMode = 0 then do
      x.l = 'Passive'
   end
   when rc = 1 & mr.FtpMode = 1 then do
      x.l = 'Active'
   end
   otherwise do
      rc = FtpSetActiveMode( 1 )
      x.l = 'Active (default)'
   end
end
say '            FTP Mode is '||mr.b.Y||x.l||mr.n.W

/**************************************************************************/
/* 室  砫 ⠫                                          */
/**************************************************************************/
rc = Stream( mr.OutFile, 'C', 'OPEN WRITE' )
rc = 0
if ftp.Dir \= '' then do
   rc = FtpChDir( ftp.Dir )
   rc = xCheckError( rc, 'FtpChDir('||ftp.Dir||')' )
end
if rc \= 0 then do
   signal halt
end

/**************************************************************************/
/* 砥 ॠ쭮  砫쭮 ⠫                              */
/**************************************************************************/
rc = FtpPwd( xPwd )
rc = xCheckError( rc, 'FtpPwd()' )
if rc \= 0 then do
   signal halt
end

parse var xPwd . '"' xCurPwd '"' .
mr.Save.1 = xCurPwd
mr.Save.0 = 1
x.l = 'Real Start Directory is '
x.l = x.l||mr.b.Y||xCurPwd||mr.n.W
say x.l

say mr.c.Reset
say mr.b.W||'If you want to break the execution, then press '|| ,
   mr.b.R||'Ctrl-C'||mr.b.W||' at any time.'||mr.n.W

/**************************************************************************/
/* 窠 ⠭ ᫥ ᠭ ணࠬ                         */
/**************************************************************************/
signal off halt
restore:
signal on halt
if mr.IsRestore then do
   xCurPwd = mr.Save.1
   mr.CurrentLevel = 0
   rc = FtpChDir( xCurPwd )
   rc = xCheckError( rc, 'FtpChDir('||xCurPwd||')' )
   if rc \= 0 then do
      signal halt
   end
end

/**************************************************************************/
/* 砥 ᮤন ⠫ ४ᨢ                               */
/**************************************************************************/
say mr.c.Reset
rc = xGetDir( xCurPwd )

/**************************************************************************/
/* 襭 ࠡ                                                      */
/**************************************************************************/
rc = Stream( mr.OutFile, 'C', 'CLOSE' )
rc = FtpLogoff( )
rc = xCheckError( rc, 'FtpLogoff()' )
say mr.c.Reset
say 'Finish: '||Date('L')||' '||Time('N')|| ,
    '   (started at '||mr.StartDate||' '||mr.StartTime||')'
exit


/**************************************************************************/
/* halt:                                                                  */
/*========================================================================*/
/* ᠭ: ࠡ⪠  Ctrl-C  Ctrl-Break                        */
/*------------------------------------------------------------------------*/
halt:
   if \mr.IsHalt then do
      x.n = SIGL
      x.s = Strip(SourceLine( x.n ))
      signal on halt
      mr.IsHalt = 1
      x.t = Time( 'E' )
      x.t = SubStr( x.t, 1, Pos( '.', x.t )+2 )
      rc = Time( 'R' )

      if x.t > mr.TimeOut then do
         x.l = ''
         say mr.c.Reset
         say mr.b.W||'May be the program hangs. Run time exceed timeout on line '|| ,
             mr.b.R||x.n||mr.b.W||': '||mr.b.Y||x.t||' sec.'||mr.n.W
         say ''
         say mr.b.W||'Line '||mr.b.R||x.n||mr.b.W||': '||mr.n.W||x.s
         say ''
         say mr.b.W||'Press '||mr.b.R||'Ctrl-C'|| ,
             mr.b.W||' to confirm the termination or '|| ,
             mr.b.R||'ESC'||mr.b.W||' to continue from the breakpoint.'||mr.n.W||mr.c.Mu
         do forever
            x.l = SysGetKey( 'NOECHO' )
            if x.l = '1B'x then do
               leave
            end
            else do
               rc = Beep( 524, 100 )
            end
         end
         if x.l = '1B'x then do
            mr.IsRestore = 1
            mr.IsHalt = 0
            signal off halt
            signal restore
         end
      end
   end

   signal off halt
   rc = Stream( mr.OutFile, 'C', 'CLOSE' )
   rc = FtpLogoff( )
   rc = xCheckError( rc, 'FtpLogoff()' )
   say mr.c.Reset
   say 'Break: '||Date('L')||' '||Time('N')|| ,
       '   (started at '||mr.StartDate||' '||mr.StartTime||')'
   exit
/*------------------------------------------------------------------------*/
/*  ࠡ稪 halt:                                                */
/**************************************************************************/


/**************************************************************************/
/* xGetDir()                                                              */
/*========================================================================*/
/* ᠭ:  ᮤন ⥪饣 ⠫.                       */
/*           ᯮ ४ᨢ.                                     */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xGetDir( pDir )                                                */
/*                                                                        */
/* ࠬ:                                                          */
/*    pDir -  ⠫,    ⥪騬                    */
/*                                                                        */
/* :                                                               */
/*    rc = 0 - ᥣ                                                     */
/*                                                                        */
/*------------------------------------------------------------------------*/
xGetDir: procedure expose mr. ftp.
   pDir = arg(1)

   if mr.IsRestore & mr.CurrentLevel < 1 then do
      rc = LineOut( mr.OutFile, '<--- restore after Ctrl-C break --->' )
   end

   mr.CurrentLevel = mr.CurrentLevel + 1
   if mr.CurrentLevel > mr.MaxLevel then do
      mr.CurrentLevel = xLevelDown( mr.CurrentLevel )
      return 0
   end

   rc = Time( 'R' )
   rc = Time( 'E' )

   rc = FtpPwd(xPwd)
   rc = xCheckError( rc, 'FtpPwd()' )
   if rc \= 0 then do
      mr.CurrentLevel = xLevelDown( mr.CurrentLevel )
      return 0
   end

   parse var xPwd . '"' xCurPwd '"' .
   if \mr.IsRestore then do
      i = mr.CurrentLevel
      mr.Save.i = xCurPwd
      mr.Save.0 = i
   end
   else do
      if mr.CurrentLevel >= mr.Save.0 then do
         mr.IsRestore = 0
      end 
   end
   x.l = xCurPwd
   say mr.c.Cl||mr.b.Y||x.l||mr.n.W||mr.c.Mu
   rc = LineOut( mr.OutFile, Copies(' ', 5*(mr.CurrentLevel-1))||x.l )

/**************************************************************************/
/*  ftp-ࢥ ⠢ ⥫ "/"   ⥪饣 ⠫,  */
/* 㣨 - .                                                          */
/**************************************************************************/
   xSlash = '/'
   if Right( xCurPwd, 1 ) = '/' then do
      xSlash = ''
   end

/**************************************************************************/
/*     ⠫,  .                              */
/* , த ᥢ ftpd 뤠 ⢥ FtpPwd()   ॣ,*/
/*  FtpDir() 頥  ⠪,     䠩 ⥬,   */
/* ..  ⮬ 孥   ॣ஢                             */
/**************************************************************************/
   select
      when mr.Sys = 'OS/2 OPERATING SYSTEM' then do
         if Translate( xCurPwd ) \= Translate( pDir ) then do
            mr.CurrentLevel = xLevelDown( mr.CurrentLevel )
            return 0
         end
      end
      when (xSlash = '') & ,
           (Length( xCurPwd ) > 1) then do
         if SubStr(xCurPwd, 1, Length(xCurPwd)-1 ) \= pDir then do
            mr.CurrentLevel = xLevelDown( mr.CurrentLevel )
            return 0
         end
      end
      otherwise do
         if xCurPwd \= pDir then do
            mr.CurrentLevel = xLevelDown( mr.CurrentLevel )
            return 0
         end
      end
   end

/**************************************************************************/
/* ⠢塞 প,  ࢥ FTP 嫥뢠:  訡      */
/**************************************************************************/
   rc = SysSleep( mr.Delay )

/**************************************************************************/
/* 砥 ᮤন ⠫                                           */
/**************************************************************************/
   rc = FtpDir( '.', 'xFile.' )
   rc = xCheckError( rc, 'FtpDir('||xCurPwd||')' )
   if rc \= 0 then do
      mr.CurrentLevel = xLevelDown( mr.CurrentLevel )
      return 0
   end

   if xFile.0 > 0 then do
      do i = 1 to xFile.0
         mr.File.i = xFile.i
      end
   end
   mr.File.0 = xFile.0

   rc = xCheckList( )

   if mr.File.0 > 0 then do
      do i = 1 to mr.File.0
         xFile.i = mr.File.i
      end
   end
   xFile.0 = mr.File.0

   if xFile.0 > 0 then do
      do i = 1 to xFile.0
         xName = xGetName( xFile.i )
         if mr.IsRestore then do
            if xIsFoundRestore( xName ) then do
               xName = xCurPwd||xSlash||xName
               rc = FtpChDir( xName )
               rc = xCheckError( rc, 'FtpChDir('||xName||')' )
               if rc = 0 then do
                  rc = xGetDir( xName )
               end
            end
            else do
               if i = xFile.0 then do
                  mr.IsRestore = 0
               end
            end
         end
         else do
            if xIsDir( xFile.i ) & ,
               ( mr.CurrentLevel < mr.MaxLevel ) then do

               xName = xCurPwd||xSlash||xName
               rc = FtpChDir( xName )
               rc = xCheckError( rc, 'FtpChDir('||xName||')' )
               if rc = 0 then do
                  rc = xGetDir( xName )
               end
            end
            else do
               if xIsDir( xFile.i ) then do
                  xName = xCurPwd||xSlash||xName
               end
               xLine = Copies(' ', 5*mr.CurrentLevel)||xName
               rc = LineOut( mr.OutFile, xLine )
            end
         end

      end /* do */
   end

   mr.CurrentLevel = xLevelDown( mr.CurrentLevel )
   return 0
/*------------------------------------------------------------------------*/
/*  㭪樨 xGetDir()                                                */
/**************************************************************************/


/**************************************************************************/
/* xIsFoundRestore()                                                      */
/*========================================================================*/
/* ᠭ: ࠢ  ⠫  ⠭               */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xIsFoundRestore( pName )                                       */
/*                                                                        */
/* ࠬ:                                                             */
/*    pName -   ⠫                                            */
/*                                                                        */
/* :                                                               */
/*    rc = 1                                                    */
/*       = 0                                                  */
/*                                                                        */
/*------------------------------------------------------------------------*/
xIsFoundRestore: procedure expose mr.
   pName = arg(1)

   rc = 0
   if mr.CurrentLevel < mr.Save.0 then do
      i = mr.CurrentLevel + 1
      xName = mr.Save.i
      if Right( xName, 1 ) = '/' then do
         xName = Left( xName, Length(xName)-1 )
      end
      xPos = LastPos( '/', xName )
      if xPos > 0 then do
         xName = SubStr( xName, xPos+1 )
         if xName \= '' then do
            if mr.Sys = 'OS/2 OPERATING SYSTEM' then do
               rc = (Translate( xName ) = Translate( pName ))
            end
            else do
               rc = (xName = pName)
            end
         end
      end
   end

   return rc;
/*------------------------------------------------------------------------*/
/*  㭪樨 xIsFoundRestore()                                        */
/**************************************************************************/


/**************************************************************************/
/* xLevelDown()                                                           */
/*========================================================================*/
/* ᠭ:  ⥪饣 ஢ ४ᨨ                           */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xLevelDown( pLevel )                                           */
/*                                                                        */
/* ࠬ:                                                             */
/*    pLevel - ⥪騩 ஢ ४ᨨ                                   */
/*                                                                        */
/* :                                                               */
/*    rc     -  ஢ ४ᨨ                                     */
/*                                                                        */
/*------------------------------------------------------------------------*/
xLevelDown: procedure expose mr.
   pLevel = arg(1)

   rc = 0
   if pLevel > 0 then do
      rc = pLevel - 1
      if pLevel > 1 then do
         drop mr.Save.pLevel
      end
      mr.Save.0 = rc
   end

   return rc;
/*------------------------------------------------------------------------*/
/*  㭪樨 xLevelDown()                                             */
/**************************************************************************/


/**************************************************************************/
/* xCheckList()                                                           */
/*========================================================================*/
/* ᠭ: ࠡ⠥ ᯨ᮪ - 䠩 ⨬  砫 ᯨ᪠,          */
/*            ⠫                                             */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xCheckList( )                                                  */
/*                                                                        */
/* ࠬ:                                                             */
/*                                                                     */
/*                                                                        */
/* :                                                               */
/*    rc = 0 - ᥣ                                                     */
/*                                                                        */
/*------------------------------------------------------------------------*/
xCheckList: procedure expose mr.
   rc = 0
   xTotal = 0

   if mr.File.0 > 0 then do
      do i = 1 to mr.File.0
         if \xIsDir( mr.File.i ) then do
            xName = xGetName( mr.File.i )
            if xName \= '' & ,
               xName \= '..' & ,
               xName \= '.' then do
               xTotal = xTotal + 1
               xFile.xTotal = mr.File.i
            end
         end
      end /* do */
      do i = 1 to mr.File.0
         if xIsDir( mr.File.i ) then do
            xTotal = xTotal + 1
            xFile.xTotal = mr.File.i
         end
      end /* do */
   end
   xFile.0 = xTotal

   if xFile.0 > 0 then do
      do i = 1 to xFile.0
         mr.File.i = xFile.i
      end /* do */
   end
   mr.File.0 = xFile.0

   return rc;
/*------------------------------------------------------------------------*/
/*  㭪樨 xCheckList()                                             */
/**************************************************************************/


/**************************************************************************/
/* xGetName()                                                             */
/*========================================================================*/
/* ᠭ:     ⢥ FTP                            */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xGetName( pLine )                                              */
/*                                                                        */
/* ࠬ:                                                             */
/*    pLine -  ⢥ FTP   DIR                             */
/*                                                                        */
/* :                                                               */
/*    rc -                                                             */
/*                                                                        */
/*------------------------------------------------------------------------*/
xGetName: procedure expose mr.
   pLine = arg(1)

   select
      when SubStr( mr.Sys, 1, 5 ) = 'UNIX ' then do
         parse var pLine xAttr x1 x1 x1 xSize x1 x1 x1 xName
      end
      when mr.Sys = 'OS/2 OPERATING SYSTEM' then do
         parse var pLine . 30 xAttr 33 . 54 xName
      end
      when SubStr( mr.Sys, 1, 10 ) = 'WINDOWS_NT' & ,
           DataType(SubStr(pLine, 1, 1), 'N') = 1 then do
         parse var pLine x1 x1 xAttr xName
      end
      when SubStr( mr.Sys, 1, 10 ) = 'WINDOWS_NT' & ,
           DataType(SubStr(pLine, 1, 1), 'N') = 0 then do
         parse var pLine xAttr x1 x1 x1 xSize x1 x1 x1 xName
      end
      otherwise do
         xName = ''
      end
   end
   rc = Strip( xName )
   return rc;
/*------------------------------------------------------------------------*/
/*  㭪樨 xGetName()                                               */
/**************************************************************************/


/**************************************************************************/
/* xIsDir()                                                               */
/*========================================================================*/
/* ᠭ: ஢ઠ  ⢥ FTP -  ⠫?                    */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xIsDir( pLine )                                                */
/*                                                                        */
/* ࠬ:                                                             */
/*    pLine -  ⢥ FTP   DIR                             */
/*                                                                        */
/* :                                                               */
/*    rc > 0 -  ⠫                                                */
/*    rc = 0 -   ⠫                                             */
/*                                                                        */
/*------------------------------------------------------------------------*/
xIsDir: procedure expose mr.
   pLine = arg(1)

   select
      when SubStr( mr.Sys, 1, 5 ) = 'UNIX ' then do
         parse var pLine xAttr x1 x1 x1 xSize x1 x1 x1 xName
         rc = ( Translate( Left( xAttr, 1 ) ) = 'D' )
      end
      when mr.Sys = 'OS/2 OPERATING SYSTEM' then do
         parse var pLine . 30 xAttr 33 . 54 xName
         rc = ( Translate( xAttr ) = 'DIR' )
      end
      when SubStr( mr.Sys, 1, 10 ) = 'WINDOWS_NT' & ,
           DataType(SubStr(pLine, 1, 1), 'N') = 1 then do
         parse var pLine x1 x1 xAttr xName
         rc = ( Translate( xAttr ) = '<DIR>' )
      end
      when SubStr( mr.Sys, 1, 10 ) = 'WINDOWS_NT' & ,
           DataType(SubStr(pLine, 1, 1), 'N') = 0 then do
         parse var pLine xAttr x1 x1 x1 xSize x1 x1 x1 xName
         rc = ( Translate( Left( xAttr, 1 ) ) = 'D' )
      end
      otherwise do
         rc = 0
      end
   end
   rc = rc & ,
        ( xName \= '..' ) & ,
        ( xName \= '.' ) & ,
        ( Strip(xName) \= '' )
   return rc;
/*------------------------------------------------------------------------*/
/*  㭪樨 xIsDir()                                                 */
/**************************************************************************/


/**************************************************************************/
/* xCheckError()                                                          */
/*========================================================================*/
/* ᠭ: ஢ઠ 訡 ftp (஬ FtpSetUser  FtpSetBinary)        */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xCheckError( pRc, pHead )                                      */
/*                                                                        */
/* ࠬ:                                                             */
/*    pRc   -   樨 ftp                                   */
/*    pHead -  ᮮ饭  訡                               */
/*                                                                        */
/* :                                                               */
/*    rc    -   樨 ftp                                   */
/*                                                                        */
/*------------------------------------------------------------------------*/
xCheckError: procedure expose mr. FTPERRNO
   pRc = arg(1)
   pHead = arg(2)

   if pRc \= 0 then do
      x.l = pHead||'   FTPERRNO='||FTPERRNO||xFtpError()
      say mr.c.Cl||mr.b.R||x.l||mr.n.W
      rc = LineOut( mr.OutFile, x.l )
   end

   rc = pRc
   return rc;
/*------------------------------------------------------------------------*/
/*  㭪樨 xCheckError()                                            */
/**************************************************************************/


/**************************************************************************/
/* xFtpError()                                                            */
/*========================================================================*/
/* ᠭ: 뢮 ᠭ 訡 ftp                                    */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xFtpError()                                                    */
/*                                                                        */
/* ࠬ:                                                          */
/*                                                                        */
/* :                                                               */
/*    rc - ப  ᠭ 訡                                      */
/*                                                                        */
/*------------------------------------------------------------------------*/
xFtpError: procedure expose FTPERRNO

   select
      when FTPERRNO = 'FTPSERVICE' then do
         rc = 'unknown service'
      end
      when FTPERRNO = 'FTPHOST' then do
         rc = 'unknown host'
      end
      when FTPERRNO = 'FTPSOCKET' then do
         rc = 'unable to obtain socket'
      end
      when FTPERRNO = 'FTPCONNECT' then do
         rc = 'unable to connect to server'
      end
      when FTPERRNO = 'FTPLOGIN' then do
         rc = 'login failed'
      end
      when FTPERRNO = 'FTPABORT' then do
         rc = 'transfer stopped'
      end
      when FTPERRNO = 'FTPLOCALFILE' then do
         rc = 'problem opening local file'
      end
      when FTPERRNO = 'FTPDATACONN' then do
         rc = 'problem initializing data connection'
      end
      when FTPERRNO = 'FTPCOMMAND' then do
         rc = 'command failed'
      end
      when FTPERRNO = 'FTPPROXYTHIRD' then do
         rc = 'proxy server does not support third party transfers'
      end
      when FTPERRNO = 'FTPNOPRIMARY' then do
         rc = 'no primary connection for proxy transfer'
      end
      otherwise do
         rc = '??? unknown error ???'
      end
   end
   rc = ' - '||rc

   return rc
/*------------------------------------------------------------------------*/
/*  㭪樨 xFtpError()                                              */
/**************************************************************************/


/**************************************************************************/
/* xFtpPingError()                                                        */
/*========================================================================*/
/* ᠭ: 뢮 ᠭ 訡 FtpPing                                */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xFtpPingError( rcping )                                        */
/*                                                                        */
/* ࠬ:                                                             */
/*    rcping -   㭪樨 FtpPing()                             */
/*                                                                        */
/* :                                                               */
/*    rc - ப  ᠭ 訡                                      */
/*                                                                        */
/*------------------------------------------------------------------------*/
xFtpPingError: procedure
   parse arg rcPing .

   select
      when rcPing = 'PINGREPLY' then do
         rc = 'host does not reply'
      end
      when rcPing = 'PINGSOCKET' then do
         rc = 'unable to obtain socket'
      end
      when rcPing = 'PINGPROTO' then do
         rc = 'unknown protocol ICMP'
      end
      when rcPing = 'PINGSEND' then do
         rc = 'send failed'
      end
      when rcPing = 'PINGRECV' then do
         rc = 'receive failed'
      end
      when rcPing = 'PINGHOST' then do
         rc = 'unknown host'
      end
      otherwise do
         rc = '??? unknown error ???'
      end
   end
   rc = ' - '||rc

   return rc
/*------------------------------------------------------------------------*/
/*  㭪樨 xFtpPingError()                                          */
/**************************************************************************/


/**************************************************************************/
/* xIsDirExist()                                                          */
/*========================================================================*/
/* ᠭ: ஢ઠ ⢮ ⠫                              */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xIsDirExist( pDir )                                            */
/*                                                                        */
/* ࠬ:                                                             */
/*    pDir -  ⠫                                            */
/*                                                                        */
/* :                                                               */
/*    rc = 1 - ⠫                                          */
/*       = 0 - ⠫                                        */
/*                                                                        */
/*------------------------------------------------------------------------*/
xIsDirExist: procedure
   pDir = arg(1)

   rc = SysFileTree( pDir, 'xFile', 'D' )
   if rc \= 0 then do
      rc =0
   end
   else do
      rc = (xFile.0 \= 0)
   end

   return rc
/*------------------------------------------------------------------------*/
/*  㭪樨 xIsDirExist()                                            */
/**************************************************************************/


/**************************************************************************/
/* xParseParam()                                                          */
/*========================================================================*/
/* ᠭ: ࠧ ࠬ஢  ப                           */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xParseParam( pParam, pId )                                     */
/*                                                                        */
/* ࠬ:                                                             */
/*    pParam - ப  ࠬࠬ                                       */
/*    pId    - 䨪 襭 ࠬ                       */
/*             'LOGIN'    -  짮⥫ ࢥ FTP                  */
/*             'PASSWORD' - ஫                                        */
/*             'HOST'     -    ࢥ FTP                     */
/*             'DIR'      - ⮢ ⠫                             */
/*             'LEVEL'    - ஢  ⠫                 */
/*             'MODE'     - ० FTP                                     */
/*             'DELAY'    - প । FtpDir                         */
/*                                                                        */
/* :                                                               */
/*    rc - 祭 襭 ࠬ                                */
/*                                                                        */
/*------------------------------------------------------------------------*/
xParseParam: procedure
   pParam = Strip(arg(1))
   pId = Translate(Strip(arg(2)))
   rc = ''

/* 뤥塞 㯯 ࠬ஢ */
   x.p1 = ''
   x.p2 = ''

   x.l = Pos( '"', pParam )
   x.r = LastPos( '"', pParam )
   if x.l \= 0 then do
      if x.l = 1 & x.r \= x.l then do
         parse var pParam '"' x.p1 '"' x.p2
         x.p2 = Strip( x.p2 )
      end
   end
   else do
      x.s = LastPos( ' ', pParam )
      if x.s \= 0 then do
         x.p1 = SubStr( pParam, 1, x.s-1 )
         x.p2 = Strip(SubStr( pParam, x.s+1 ))
      end
      else do
         x.p1 = pParam
         x.p2 = ''
      end
   end

/*  ࢮ 㯯 login, passwd, host  dir */
/*  ࠢ 祭 㡨 host  맮 ࠢ */
   if x.p1 = '' then do
      x.login = ''
      x.password = ''
      x.host = ''
      x.dir = ''
   end
   else do
      x.s = Pos( '/', x.p1 )
      if x.s \= 0 then do
         parse var x.p1 x.t '/' x.dir
         x.p1 = x.t
      end
      else do
         x.dir = ''
      end

      x.s = LastPos( '@', x.p1 )
      if x.s \= 0 then do
         x.t = SubStr( x.p1, 1, x.s-1 )
         x.host = Strip(SubStr( x.p1, x.s+1 ))
         if x.t = '' then do
            x.host = ''
         end
      end
      else do
         x.host = x.p1
         x.t = ''
      end
      x.p1 = x.t

      if x.p1 = '' then do
         x.login = 'anonymous'
         x.password = 'anonymous@guest.ftp'
      end
      else do
         x.s = Pos( ':', x.p1 )
         if x.s \= 0 then do
            parse var x.p1 x.login ':' x.password
            if x.login = '' then do
               x.host = ''
            end
         end
         else do
            x.login = x.p1
            x.password = ''
         end      
      end
   end

/*  ன 㯯 level, mode  delay */
/*  ࠢ 祭 㡨 host  맮 ࠢ */
   if x.p2 = '' then do
      x.level = 1
      x.mode = 'P'
      x.delay = 0
   end
   else do
      x.l = Pos( ':', x.p2 )
      x.r = LastPos( ':', x.p2 )
      if x.l \= 0 then do
         if x.l \= x.r then do
            parse var x.p2 x.level ':' x.mode ':' x.delay
            x.mode = Translate(Strip(x.mode))
            x.delay = Strip(x.delay)
         end
         else do
            parse var x.p2 x.level ':' x.t
            x.t = Translate(Strip(x.t))
            if DataType( x.t, 'N' ) then do
               x.mode = 'P'
               x.Delay = x.t
            end
            else do
               x.mode = x.t
               x.Delay = 0
            end
         end
         x.level = Strip(x.level)
         if x.level = '' then do
            x.level = 1
         end
      end
      else do
         x.level = Strip(x.p2)
         x.mode = 'P'
         x.delay = 0
      end
   end

   if DataType( x.level, 'N' ) then do
      if x.level < 1 then do
         x.level = 1
      end
      if x.level > 9 then do
         x.level = 9
      end
   end
   else do
      x.host = ''
   end

   if x.mode \= 'P' & x.mode \= 'A' then do
      x.host = ''
   end
   else do
      if x.mode = 'A' then do
         x.mode = 1
      end
      else do
         x.mode = 0
      end
   end

   if DataType( x.delay, 'N' ) then do
      if x.delay < 0 then do
         x.delay = 0
      end
   end
   else do
      x.host = ''
   end

   rc = x.pId
   return rc
/*------------------------------------------------------------------------*/
/*  㭪樨 xParseParam()                                            */
/**************************************************************************/


/**************************************************************************/
/* xHowUse()                                                              */
/*========================================================================*/
/* ᠭ: 뢮 ᠭ ᨭ⠪  ப  室           */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xHowUse()                                                      */
/*                                                                        */
/* ࠬ:                                                          */
/*                                                                        */
/* :                                                            */
/*                                                                        */
/*------------------------------------------------------------------------*/
xHowUse: procedure expose mr.
   say mr.c.Reset
   say 'Usage: '|| ,
        mr.b.W||'rxFtpTree'||mr.n.W||' ['|| ,
        mr.b.W||'login'||mr.n.W||'[:'|| ,
        mr.b.W||'password'||mr.n.W||']@]'|| ,
        mr.b.W||'host'||mr.n.W||'[/'|| ,
        mr.b.W||'dir'||mr.n.W||'] ['|| ,
        mr.b.W||'level'||mr.n.W||'][:'|| ,
        mr.b.W||'mode'||mr.n.W||'][:'|| ,
        mr.b.W||'delay'||mr.n.W||']'
   say ''
   say '          '||mr.b.W||'login   '||mr.n.W||' - user name'
   say '          '||mr.b.W||'password'||mr.n.W||' - user password'
   say '          '||mr.b.W||'host    '||mr.n.W||' - host name or host ip-address'
   say '          '||mr.b.W||'dir     '||mr.n.W||' - start directory'
   say '          '||mr.b.W||'level   '||mr.n.W||' - level of recursion (1-9), default: 1'
   say '          '||mr.b.W||'mode    '||mr.n.W||' - mode: a - active, p - passive (default)'
   say '          '||mr.b.W||'delay   '||mr.n.W||' - delay (in seconds), default: 0'
   say mr.c.Reset
   say 'Finish: '||Date('L')||' ('||Time('N')||')'
   exit 1;
/*------------------------------------------------------------------------*/
/*  㭪樨 xHowUse()                                                */
/**************************************************************************/


/**************************************************************************/
/* xGetAnsiValue()                                                        */
/*========================================================================*/
/* ᠭ: 樠 ANSI ᫥⥫쭮⥩  뢮  ࠭   */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xGetAnsiValue()                                                */
/*                                                                        */
/* ࠬ:                                                          */
/*                                                                        */
/* :                                                               */
/*    rc = 0 - ᥣ                                                     */
/*                                                                        */
/*------------------------------------------------------------------------*/
xGetAnsiValue: procedure expose mr.
   xEsc=x2c('1B')

/**************************************************************************/
/*   ()                                                  */
/**************************************************************************/
   mr.n.K = xEsc||'[0;30m'      /* Black   -          */
   mr.n.R = xEsc||'[0;31m'      /* Red     -         */
   mr.n.G = xEsc||'[0;32m'      /* Green   -         */
   mr.n.Y = xEsc||'[0;33m'      /* Yellow  -          */
   mr.n.B = xEsc||'[0;34m'      /* Blue    - ᨭ          */
   mr.n.M = xEsc||'[0;35m'      /* Magenta - ७      */
   mr.n.C = xEsc||'[0;36m'      /* Cyan    -       */
   mr.n.W = xEsc||'[0;37m'      /* White   -           */

/**************************************************************************/
/*   (ન)                                                    */
/**************************************************************************/
   mr.b.K = xEsc||'[1;30m'      /* Black   -          */
   mr.b.R = xEsc||'[1;31m'      /* Red     -         */
   mr.b.G = xEsc||'[1;32m'      /* Green   -         */
   mr.b.Y = xEsc||'[1;33m'      /* Yellow  -          */
   mr.b.B = xEsc||'[1;34m'      /* Blue    - ᨭ          */
   mr.b.M = xEsc||'[1;35m'      /* Magenta - ७      */
   mr.b.C = xEsc||'[1;36m'      /* Cyan    -       */
   mr.b.W = xEsc||'[1;37m'      /* White   -           */

/**************************************************************************/
/*  䮭                                                              */
/**************************************************************************/
   mr.g.K = xEsc||'[0;40m'      /* Black   -          */
   mr.g.R = xEsc||'[0;41m'      /* Red     -         */
   mr.g.G = xEsc||'[0;42m'      /* Green   -         */
   mr.g.Y = xEsc||'[0;43m'      /* Yellow  -          */
   mr.g.B = xEsc||'[0;44m'      /* Blue    - ᨭ          */
   mr.g.M = xEsc||'[0;45m'      /* Magenta - ७      */
   mr.g.C = xEsc||'[0;46m'      /* Cyan    -       */
   mr.g.W = xEsc||'[0;47m'      /* White   -           */

/**************************************************************************/
/* Windowed - ન 梥 䮭 (Full Screen - 栭)                    */
/**************************************************************************/
   mr.f.K = xEsc||'[5;40m'      /* Black   -          */
   mr.f.R = xEsc||'[5;41m'      /* Red     -         */
   mr.f.G = xEsc||'[5;42m'      /* Green   -         */
   mr.f.Y = xEsc||'[5;43m'      /* Yellow  -          */
   mr.f.B = xEsc||'[5;44m'      /* Blue    - ᨭ          */
   mr.f.M = xEsc||'[5;45m'      /* Magenta - ७      */
   mr.f.C = xEsc||'[5;46m'      /* Cyan    -       */
   mr.f.W = xEsc||'[5;47m'      /* White   -           */

/**************************************************************************/
/* ਡ                                                               */
/**************************************************************************/
   mr.a.O = xEsc||'[0m'         /* Off        -  몫祭             */
   mr.a.B = xEsc||'[1m'         /* Bold       - 襭 મ         */
   mr.a.N = xEsc||'[2m'         /* Normal     - 筠 મ           */
   mr.a.L = xEsc||'[5m'         /* Blind      - 栭(FS) ન 䮭(W) */
   mr.a.I = xEsc||'[7m'         /* Inverse    -                   */
   mr.a.V = xEsc||'[8m'         /* Invisible  -                  */

/**************************************************************************/
/*                                                                 */
/**************************************************************************/
   mr.c.Cs = xEsc||'[2J'        /* ⪠ ᥣ ࠭         */
   mr.c.Cl = xEsc||'[0K'        /* ⪠ ப      */
   mr.c.Mu = xEsc||'[1A'        /*   1 ப      */
   mr.c.Md = xEsc||'[1B'        /*   1 ப       */
   mr.c.Mr = xEsc||'[1C'        /*   1 ⮫ ࠢ   */
   mr.c.Ml = xEsc||'[1D'        /*   1 ⮫     */
   mr.c.Ps = xEsc||'[1s'        /*       */
   mr.c.Pr = xEsc||'[1u'        /* ⠭   */

   mr.c.Reset = mr.a.O||mr.g.K||mr.n.W
   return 0
/*------------------------------------------------------------------------*/
/*  㭪樨 xGetAnsiValue()                                          */
/**************************************************************************/


/*------------------------------------------------------------------------*/
/*  䠩 rxFtpTree.cmd                                              */
/**************************************************************************/

